
package de.ivu.elect.was.exchange.ergebnis;

import static java.util.stream.Collectors.toSet;

import java.util.Collection;

import javax.annotation.Nullable;

import de.ivu.elect.business.datei.entity.Datei;
import de.ivu.elect.business.wahl.control.AbstractNlExportArtefaktNachSystemExportstatusExportContext;
import de.ivu.elect.core.exchange.wahl.AbstractNlExportArtefaktNachSystemExportstatusZipExportMapper;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.presentation.ergebnis.exchange.NlWasModelE2BulkExportDescription;
import de.ivu.elect.was.exchange.wahl.NlWasExportArtefaktNachSystemExportstatusExportMapperResolver;

public class NlWasModelE2ZipExportMapper extends AbstractNlExportArtefaktNachSystemExportstatusZipExportMapper implements NlWasModelE2BulkExportMapper {

  public static final String FILE_FORMAT_NAME = NlWasModelE2BulkExportDescription.FILE_FORMAT_NAME;

  public NlWasModelE2ZipExportMapper() {
    super();
  }

  @Override
  public String getFileFormatName() {
    return FILE_FORMAT_NAME;
  }

  @Override
  public void addProperties(FormBuilder formBuilder, AbstractNlExportArtefaktNachSystemExportstatusExportContext context, @Nullable Datei datei) {
    NlWasModelE2BulkExportMapper.super.addProperties(formBuilder, context, datei);

    super.addProperties(formBuilder, context, datei);
  }

  @Override
  protected Collection<NlWasModelE2ExportMapper> collectSimpleExportMappersIgnoringSystemExportstatus(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return getExportMapperResolver().collectModelE2ExportMappers().stream() //
        .filter(exportMapper -> exportMapper.isAcceptContextIgnoringSystemExportstatus(context)) //
        .collect(toSet());
  }

  @Override
  protected NlWasExportArtefaktNachSystemExportstatusExportMapperResolver getExportMapperResolver() {
    return (NlWasExportArtefaktNachSystemExportstatusExportMapperResolver) super.getExportMapperResolver();
  }
}
